"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.convertEventsToEventStreamEvents = void 0;
var __1 = require("..");
var events_api_client_1 = require("../events-api-client/events-api-client");
var create_event_from_api_response_1 = require("./create-event-from-api-response");
function convertEventsToEventStreamEvents(eventsArray) {
    var results = [];
    eventsArray.forEach(function (event) {
        if (isCommentEvent(event.type)) {
            results.push(create_event_from_api_response_1.createEventFromApiResponse(event, __1.EventStreamActionType.comment));
        }
        else if (isDefectEvent(event.type)) {
            results.push(create_event_from_api_response_1.createEventFromApiResponse(event, __1.EventStreamActionType.defect));
        }
    });
    return results.reverse();
}
exports.convertEventsToEventStreamEvents = convertEventsToEventStreamEvents;
function isCommentEvent(type) {
    return type === events_api_client_1.EventType.Comment;
}
function isDefectEvent(type) {
    return type === events_api_client_1.EventType.AddCrashDefect
        || type === events_api_client_1.EventType.RemoveCrashDefect
        || type === events_api_client_1.EventType.AddStackKeyDefect
        || type === events_api_client_1.EventType.RemoveStackKeyDefect;
}
//# sourceMappingURL=event.js.map