"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SymbolsApiClient = void 0;
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var rxjs_1 = require("rxjs");
var util_1 = __importDefault(require("util"));
var exists_1 = require("../exists");
var s3_api_client_1 = require("../s3-api-client/s3-api-client");
var stat = util_1.default.promisify(fs_1.default.stat);
var SymbolsApiClient = (function () {
    function SymbolsApiClient(_client) {
        this._client = _client;
        this.route = '/api/symbols';
        this._stat = stat;
        this._timer = rxjs_1.timer;
    }
    SymbolsApiClient.prototype.delete = function (database, application, version) {
        return __awaiter(this, void 0, void 0, function () {
            var route, init, response, json;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        route = this.route + "?dbName=" + database + "&appName=" + application + "&appVersion=" + version;
                        init = {
                            method: 'DELETE',
                            cache: 'no-cache',
                            credentials: 'include',
                            redirect: 'follow'
                        };
                        return [4, this._client.fetch(route, init)];
                    case 1:
                        response = _a.sent();
                        if (response.status !== 200) {
                            throw new Error("Error deleting symbols for " + database + "-" + application + "-" + version + " status " + response.status);
                        }
                        return [4, response.json()];
                    case 2:
                        json = _a.sent();
                        if (json.Status === 'Failed') {
                            throw new Error(json.Error);
                        }
                        return [2, response];
                }
            });
        });
    };
    SymbolsApiClient.prototype.post = function (database, application, version, files) {
        return __awaiter(this, void 0, void 0, function () {
            var promises;
            var _this = this;
            return __generator(this, function (_a) {
                promises = files
                    .map(function (file) { return __awaiter(_this, void 0, void 0, function () {
                    var stats, size, name, presignedUrl, s3Client, response;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                if (!exists_1.exists(file)) {
                                    throw new Error("File does not exist at path: " + file + "!");
                                }
                                return [4, this._stat(file)];
                            case 1:
                                stats = _a.sent();
                                size = stats.size;
                                name = path_1.default.basename(file);
                                return [4, this.getPresignedUrl(database, application, version, size, name)];
                            case 2:
                                presignedUrl = _a.sent();
                                s3Client = new s3_api_client_1.S3ApiClient();
                                response = s3Client.uploadFileToPresignedUrl(presignedUrl, file, size);
                                return [4, rxjs_1.lastValueFrom(this._timer(1000))];
                            case 3:
                                _a.sent();
                                return [2, response];
                        }
                    });
                }); });
                return [2, Promise.all(promises)];
            });
        });
    };
    SymbolsApiClient.prototype.getPresignedUrl = function (dbName, appName, appVersion, size, symFileName) {
        return __awaiter(this, void 0, void 0, function () {
            var formData, init, response, json;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        formData = this._client.createFormData();
                        formData.append('dbName', dbName);
                        formData.append('appName', appName);
                        formData.append('appVersion', appVersion);
                        formData.append('size', size.toString());
                        formData.append('symFileName', symFileName);
                        init = {
                            method: 'POST',
                            body: formData,
                            cache: 'no-cache',
                            credentials: 'include',
                            redirect: 'follow'
                        };
                        return [4, this._client.fetch(this.route, init)];
                    case 1:
                        response = _a.sent();
                        if (response.status !== 200) {
                            throw new Error("Error getting presignedUrl for " + symFileName);
                        }
                        return [4, response.json()];
                    case 2:
                        json = _a.sent();
                        if (json.Status === 'Failed') {
                            throw new Error(json.Error);
                        }
                        return [2, json.url];
                }
            });
        });
    };
    return SymbolsApiClient;
}());
exports.SymbolsApiClient = SymbolsApiClient;
//# sourceMappingURL=symbols-api-client.js.map