import fetchPonyfill from 'fetch-ponyfill';
import fs from 'fs';
import { exists } from '../exists';
export class S3ApiClient {
    constructor() {
        this._fetch = fetchPonyfill().fetch;
        this._fs = fs;
    }
    async uploadFileToPresignedUrl(presignedUrl, file, size) {
        if (!exists(file)) {
            throw new Error(`File does not exist at path: ${file}!`);
        }
        const response = await this._fetch(presignedUrl, {
            method: 'PUT',
            headers: {
                'content-type': 'application/octet-stream',
                'content-length': `${size}`
            },
            body: this._fs.createReadStream(file),
        });
        if (response.status !== 200) {
            throw new Error(`Error uploading ${file} to presignedUrl`);
        }
        return response;
    }
}
//# sourceMappingURL=s3-api-client.js.map